var MfwJsSDKBaseTool = {};
var MfwJsSDK = {};

MfwJsSDKBaseTool.changeBlockDict = {};
MfwJsSDKBaseTool.failBlockDict = {};
MfwJsSDKBaseTool.cancelBlockDict = {};
MfwJsSDKBaseTool.finishBlockDict = {};
MfwJsSDKBaseTool.uniqueId = 0;
MfwJsSDKBaseTool.dataQueue = [];

MfwJsSDKBaseTool.isRunning = false;


MfwJsSDKBaseTool.enabled = navigator.userAgent.indexOf("mfwjssdk/") != -1;

MfwJsSDKBaseTool.run = function()
{
    if (!MfwJsSDKBaseTool.isRunning && MfwJsSDKBaseTool.dataQueue.length > 0)
    {
        MfwJsSDKBaseTool.isRunning = true;
        window.location.href = MfwJsSDKBaseTool.dataQueue.shift();
    }
};

MfwJsSDKBaseTool.hello = function()
{
    MfwJsSDKBaseTool.isRunning = false;
    MfwJsSDKBaseTool.run();
};

MfwJsSDKBaseTool.execData = function (action,
                                      paramDict,
                                      changeBlock,
                                      cancelBlock,
                                      failBlock,
                                      finishBlock)
{
    if (MfwJsSDKBaseTool.enabled == false)
    {
        return;
    }
    var callBackId = 'cb_'+(MfwJsSDKBaseTool.uniqueId++)+'_'+new Date().getTime();
    var data = {"action":action,
        "data":paramDict,
        "callBackId":callBackId};
    
    MfwJsSDKBaseTool.changeBlockDict[callBackId] = changeBlock;
    MfwJsSDKBaseTool.failBlockDict[callBackId] = failBlock;
    MfwJsSDKBaseTool.cancelBlockDict[callBackId] = cancelBlock;
    MfwJsSDKBaseTool.finishBlockDict[callBackId] = finishBlock;
    
    var href = "http://EE2BA792-3EBA-8932-32D0-1711829CC789/" + encodeURIComponent(JSON.stringify(data));
    MfwJsSDKBaseTool.dataQueue.push(href);
    MfwJsSDKBaseTool.run();
};

MfwJsSDKBaseTool.onChange = function (callBackDictEncodeString)
{
    var callBackDict = JSON.parse(decodeURIComponent(callBackDictEncodeString));
    var callBackId = callBackDict.callBackId;
    var block = MfwJsSDKBaseTool.changeBlockDict[callBackId];
    block(callBackDict.data);
};

MfwJsSDKBaseTool.clearBlock = function(callbackId)
{
    MfwJsSDKBaseTool.changeBlockDict[callbackId] = null;
    MfwJsSDKBaseTool.failBlockDict[callbackId] = null;
    MfwJsSDKBaseTool.cancelBlockDict[callbackId] = null;
    MfwJsSDKBaseTool.finishBlockDict[callbackId] = null;
};

MfwJsSDKBaseTool.onFail = function (callBackDictEncodeString)
{
    var callBackDict = JSON.parse(decodeURIComponent(callBackDictEncodeString));
    var callBackId = callBackDict.callBackId;
    var block = MfwJsSDKBaseTool.failBlockDict[callBackId];
    block(callBackDict.data);
    MfwJsSDKBaseTool.clearBlock();
};

MfwJsSDKBaseTool.onCancel = function (callBackDictEncodeString)
{
    var callBackDict = JSON.parse(decodeURIComponent(callBackDictEncodeString));
    var callBackId = callBackDict.callBackId;
    var block = MfwJsSDKBaseTool.cancelBlockDict[callBackId];
    block(callBackDict.data);
    MfwJsSDKBaseTool.clearBlock();
};

MfwJsSDKBaseTool.onFinish = function (callBackDictEncodeString)
{
    var callBackDict = JSON.parse(decodeURIComponent(callBackDictEncodeString));
    var callBackId = callBackDict.callBackId;
    var block = MfwJsSDKBaseTool.finishBlockDict[callBackId];
    block(callBackDict.data);
    MfwJsSDKBaseTool.clearBlock();
};

MfwJsSDK.checkApi = function (apiArr,onFinish)
{
    var data = {"apis":apiArr};
    MfwJsSDKBaseTool.execData("checkApi",
                              data,
                              null,
                              null,
                              null,
                              function(callBackDict)
                              {
                                var resultArr = callBackDict.result;
                                var callBackArr = [];
                                for(var i=0 ; i<resultArr.length ; i++)
                                {
                                    var dict = resultArr[i];
                                    callBackArr[i] ={"api":dict.api,
                                    "isExist":dict.isExist == "true"};
                                }
                                onFinish(callBackArr);
                              }
                              );
};

MfwJsSDK.pickDate = function (beginDate,endDate,onCancel,onFinish)
{
    var data = {"begin":beginDate,
        "end":endDate};
    MfwJsSDKBaseTool.execData("pickDate",
                              data,
                              null,
                              function()
                              {
                              onCancel();
                              },
                              null,
                              function(callBackDict)
                              {
                              onFinish(callBackDict.begin,
                                       callBackDict.end);
                              });
};

MfwJsSDK.showImages = function (imgarr,index)
{
    var data = {"imgs":imgarr,
        "index":index};
    MfwJsSDKBaseTool.execData("showImages",
                              data,
                              null,
                              null,
                              null,
                              null);
};

MfwJsSDK.isAlipayAvailable = function (onFinish)
{
    var data = {};
    MfwJsSDKBaseTool.execData("isAlipayAvailable",
                              data,
                              null,
                              null,
                              null,
                              function(callBackDict)
                              {
                              
                              onFinish(callBackDict.available == "true");
                              });
};

MfwJsSDK.isWeixinPayAvailable = function (onFinish)
{
    var data = {};
    MfwJsSDKBaseTool.execData("isWeixinPayAvailable",
                              data,
                              null,
                              null,
                              null,
                              function(callBackDict)
                              {
                              onFinish(callBackDict.available == "true");
                              });
};

MfwJsSDK.payWithAlipay = function (str,
                                   onFinish)
{
    var data = {"orderString":str};
    MfwJsSDKBaseTool.execData("payWithAlipay",
                              data,
                              null,
                              null,
                              null,
                              function(callBackDict)
                              {
                              onFinish(callBackDict);
                              });
};

MfwJsSDK.scanCard = function (onFinish)
{
    var data = {};
    MfwJsSDKBaseTool.execData("scanCard",
                              data,
                              null,
                              null,
                              null,
                              function(callBackDict)
                              {
                                onFinish(callBackDict.number,
                                         callBackDict.expiryMonth,
                                         callBackDict.expiryYear,
                                         callBackDict.cvv);
                              }
                              );
}

MfwJsSDK.setRightButtonTitleAndImgUrl = function (title,url,onClick)
{
    var data = {"title":title,
        "url":url};
    MfwJsSDKBaseTool.execData("setRightButtonTitleAndImgUrl",
                              data,
                              function(callBackDict)
                              {
                              onClick();
                              },
                              null,
                              null,
                              null);
};

MfwJsSDK.setTitle = function (title)
{
    var data = {"title":title};
    MfwJsSDKBaseTool.execData("setTitle",
                              data,
                              null,
                              null,
                              null,
                              null);
};

MfwJsSDK.setTitleImgUrl = function (url)
{
    var data = {"url":url};
    MfwJsSDKBaseTool.execData("setTitleImgUrl",
                              data,
                              null,
                              null,
                              null,
                              null);
};

MfwJsSDK.setSubTitle = function (title)
{
    var data = {"title":title};
    MfwJsSDKBaseTool.execData("setSubTitle",
                              data,
                              null,
                              null,
                              null,
                              null);
};

MfwJsSDK.setSubTitleImgUrl = function (url)
{
    var data = {"url":url};
    MfwJsSDKBaseTool.execData("setSubTitleImgUrl",
                              data,
                              null,
                              null,
                              null,
                              null);
};

MfwJsSDK.close = function()
{
    var data = {};
    MfwJsSDKBaseTool.execData("close",
                              data,
                              null,
                              null,
                              null,
                              null);
};
